//==== History ====//
//R05	100309	Add debug command output display.
//		Fix coding error.
//R04	080122	Add I/O port 48Fh control.
//R03	070518	Change I/O port from 498h to 48Ch.
//R02	061213	Add I/O port 498h control.
//R01	041115	Add I/O port 4B8h control.
//		Add debug message.
//R00	040416	First release.

#include <stdio.h>
#include <dos.h>
#include <conio.h>

#define	CDBoxOpenDelay		300	//Delay time for Cash Drawer open

//int ChangeCDBoxCtl(int CDBoxCtlIO, int CDBoxCtlData, int CtlIObit);
void ChangeCDBoxCtl(int CDBoxCtlIO, int CDBoxCtlData, int CtlIObit);
void showBitB(int showData);

	char APName[]=	"Cash Drawer Debug Program   V1.4a (10'03/09) by Nigel Feng\n";

	char APHelp[]=
		"\n* Hot key for change Cash Draw controller DOUT output level:"
		"\n\n\tControl & status port  \\|bit3\tbit2\tbit1\tbit0"
		"\n\t------------------------|----\t----\t----\t----"
		"\n\t\t200 & 201\t| Q\t W\t E\t R"
		"\n\t\t206 & 206\t| A\t S\t D\t F"
		"\n\t\t4B8 & 4B8\t| Z\t X\t C\t V"
		"\n\t\t48C & 48C\t| T\t Y\t U\t I"
		"\n\t\t48F & 48F\t| G\t H\t J\t K"
		"\n\n* Pass '0' key for Exit program.";

void main(void){
	int	PortNow200, PortCtl200,
		PortNow201, PortSts201,
		PortNow206, PortCtl206=0, PortSts206,
		PortNow48C, PortCtl48C=0, PortSts48C,
		PortNow48F, PortCtl48F=0, PortSts48F,
		PortNow4B8, PortCtl4B8=0, PortSts4B8;
	char	getkey = 0;
	int	UpdateCounter=0;

	clrscr();	//clear screen
	printf(APName);
	printf(APHelp);

	do{
		//Get port value, shift and mask for CDBox Control & CDBox Status.
		PortNow200 = inportb(0x200);
		PortCtl200 = PortNow200 & 0xF;

		PortNow201 = inportb(0x201);
		PortSts201 = PortNow201 & 0xF;

		PortNow206 = inportb(0x206);
		PortSts206 = PortNow206 & 0xF;
		PortCtl206 = PortNow206 & 0x3;

		PortNow4B8 = inportb(0x4B8);
		PortSts4B8 = (PortNow4B8 >> 4) & 0x3;	//the status bit in IO port 4B8 bit5~4.
		PortCtl4B8 = PortNow4B8 & 0xF;		//the control bit in IO port 4B8 bit3~0.

		PortNow48C = inportb(0x48C);
		PortSts48C = (PortNow48C >> 6) & 0x3;	//the status bit in IO port 48C bit7~6.
		PortCtl48C = (PortNow48C >> 2) & 0xF;	//the control bit in IO port 48C bit5~2.

		PortNow48F = inportb(0x48F);
		PortSts48F = (PortNow48F >> 5) & 0x3;	//the status bit in IO port 48F bit6~5.
		PortCtl48F = ((PortNow48F >> 1) & 0xC)+(PortNow48F & 0x3);	//the control bit in IO port 48F bit4,3,1,0.

		gotoxy (1,14);
		printf(   "I/O 0x200 (%02xh) Control = ",PortNow200);	showBitB(PortCtl200);
		printf( "\nI/O 0x201 (%02xh) Status  = ",PortNow201);	showBitB(PortSts201);
		printf( "\nI/O 0x206 (%02xh) Control = ",PortNow206);	showBitB(PortCtl206);
		printf( "\nI/O 0x206 (%02xh) Status  = ",PortNow206);	showBitB(PortSts206);
		printf( "\nI/O 0x4B8 (%02xh) Control = ",PortNow4B8);	showBitB(PortCtl4B8);
		printf( "\nI/O 0x4B8 (%02xh) Status  = ",PortNow4B8);	showBitB(PortSts4B8);
		printf( "\nI/O 0x48C (%02xh) Control = ",PortNow48C);	showBitB(PortCtl48C);
		printf( "\nI/O 0x48C (%02xh) Status  = ",PortNow48C);	showBitB(PortSts48C);
		printf( "\nI/O 0x48F (%02xh) Control = ",PortNow48F);	showBitB(PortCtl48F);
		printf( "\nI/O 0x48F (%02xh) Status  = ",PortNow48F);	showBitB(PortSts48F);

		UpdateCounter++;
		switch (UpdateCounter){
			case 4: UpdateCounter=0;
			case 0: printf("-"); break;
			case 1: printf("/"); break;
			case 2: printf("|"); break;
			case 3: printf("\\");break;
		}

		printf("\b");
		delay(100);

		if (kbhit()){
			getkey = getch();
			switch (getkey){
				case 'q':
				case 'Q':
					ChangeCDBoxCtl(0x200, PortNow200, 8);	break;
				case 'w':
				case 'W':
					ChangeCDBoxCtl(0x200, PortNow200, 4);	break;
				case 'e':
				case 'E':
					ChangeCDBoxCtl(0x200, PortNow200, 2);	break;
				case 'r':
				case 'R':
					ChangeCDBoxCtl(0x200, PortNow200, 1);	break;

				case 'a':
				case 'A':
					ChangeCDBoxCtl(0x206, PortNow206, 8);	break;
				case 's':
				case 'S':
					ChangeCDBoxCtl(0x206, PortNow206, 4);	break;
				case 'd':
				case 'D':
					ChangeCDBoxCtl(0x206, PortNow206, 2);	break;
				case 'f':
				case 'F':
					ChangeCDBoxCtl(0x206, PortNow206, 1);	break;

				case 'z':
				case 'Z':
					ChangeCDBoxCtl(0x4B8, PortNow4B8, 8);	break;
				case 'x':
				case 'X':
					ChangeCDBoxCtl(0x4B8, PortNow4B8, 4);	break;
				case 'c':
				case 'C':
					ChangeCDBoxCtl(0x4B8, PortNow4B8, 2);	break;
				case 'v':
				case 'V':
					ChangeCDBoxCtl(0x4B8, PortNow4B8, 1);	break;

				case 't':
				case 'T':
					ChangeCDBoxCtl(0x48C, PortNow48C, 0x20);	break;
				case 'y':
				case 'Y':
					ChangeCDBoxCtl(0x48C, PortNow48C, 0x10);	break;
				case 'u':
				case 'U':
					ChangeCDBoxCtl(0x48C, PortNow48C, 0x08);	break;
				case 'i':
				case 'I':
					ChangeCDBoxCtl(0x48C, PortNow48C, 0x04);	break;

				case 'g':
				case 'G':
					ChangeCDBoxCtl(0x48F, PortNow48F, 0x10);	break;
				case 'h':
				case 'H':
					ChangeCDBoxCtl(0x48F, PortNow48F, 0x08);	break;
				case 'j':
				case 'J':
					ChangeCDBoxCtl(0x48F, PortNow48F, 0x02);	break;
				case 'k':
				case 'K':
					ChangeCDBoxCtl(0x48F, PortNow48F, 0x01);	break;
			};
			printf( ",Input: [%c]        ", getkey);
		};
	}while (getkey != '0');
}


//int ChangeCDBoxCtl(int CDBoxCtlIO, int CDBoxCtlData, int CtlIObit){
//	CDBoxCtlData ^= CtlIObit;	//xor
//	outportb(CDBoxCtlIO, CDBoxCtlData);
//	printf( "(O %X %02X)    ", CDBoxCtlIO, CDBoxCtlData);	//R05
//	#ifdef	CDBoxOpenDelay
//		delay(CDBoxOpenDelay);	//Delay time for Cash Drawer open
//	#endif	CDBoxOpenDelay
//	return CDBoxCtlData;
//}

void ChangeCDBoxCtl(int CDBoxCtlIO, int CDBoxNowData, int CtlIObit){
	CDBoxNowData ^= CtlIObit;	//xor
	outportb(CDBoxCtlIO, CDBoxNowData);
	printf( "\t\t(O %X %02X)", CDBoxCtlIO, CDBoxNowData);
	#ifdef	CDBoxOpenDelay
		delay(CDBoxOpenDelay);	//Delay time for Cash Drawer open
	#endif	CDBoxOpenDelay
}

void showBitB(int showData){
	int a=0x10;
	do{
		a >>= 1;
		printf("%c", ((showData & a) == 0) ? '0':'1');
	}while (a != 1);
	printf("b");
}
