//==== History ====//
//R00	080122	First release.
//R01 	091016	Modify for Linux version 

#include <iostream>
#include "CDB48Fx2.h"
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <termios.h>
#include <sys/io.h>
using namespace std;
#define outp(a,b)	outb(b,a)
#define	inp(a)	inb(a)
#define	CDBoxOpenDelay		300000	//Delay time for Cash Drawer open
static struct termios inital_settings,new_settings;
static int peek_character = -1;

void	CDBoxCMD(int CDBoxCMDValue );


char APName[]=	      "\t\tCash Drawer Testing Program\n"
		"\t===========================================\n" ;

char APHelp[]=	"\n - Pass '1' key for open Cash Drawer 1"
		"\n - Pass '2' key for open Cash Drawer 2"
		"\n - Pass '3' key for open both of Cash Drawer 1 and Cash Drawer 2"
		"\n - Pass '0' key for Exit"
		"\n" ;

// clrscr //clean display 
void clrscr(void)
{
	int i;
	for (i=0; i<100;i++)
		putchar('\n');
}

void	CDBoxCMD(int CDBoxCMDValue ){
	outp(CDBoxCtlIO, CDBoxCMDValue);	//Control value
	usleep(CDBoxOpenDelay);			//Delay time for Cash Drawer open
	outp(CDBoxCtlIO, CDBoxCtlCMDAllowClose);	//Allow Close Cash Drawer
}


int main(void)
{
	
	int	PortStatus, OldPortStatus = 0xff;
	char	getkey = 0;
	int ch=0,chk=0;
	char number;
	
	//init_keyboard();
	
	//----------
	for(;;){
	clrscr();	//clear screen	
	printf(APName);
	printf(APHelp);

	printf(	"\nCash Drawer Control Register\t: I/O 0x%X", CDBoxCtlIO);
	printf(	"\nCash Drawer Status Register\t: I/O 0x%X\n", CDBoxStsIO);
	ioperm(CDBoxCtlIO, 3, 1);
	chk=inb(CDBoxCtlIO);

	//printf("original value of port 0x%.2x\n",chk);
	PortStatus = ((ioperm(CDBoxStsIO,3,1)) & CDBoxStsIOMask);
	//----------
	if (OldPortStatus != PortStatus){
			OldPortStatus == PortStatus;
			//gotoxy (1,12);
			printf ("\n\tCash Drawer 1 Status :");
			if((PortStatus & CDBox1StsBit) == 0)
				printf(CDBoxStsIs0Str);	// =0
			else
				printf(CDBoxStsIs1Str);	// =1

			printf ("\n\tCash Drawer 2 Status : ");
			if((PortStatus & CDBox2StsBit) == 0)
				printf(CDBoxStsIs0Str);	// =0
			else
				printf(CDBoxStsIs1Str);	// =1
		};
		cin >> number ;
		switch(number)
		{
			case '1':	
				printf(" Press '1' key for open Cash Drawer 1\n");
				CDBoxCMD( CDBoxCtlCMDOpen1);
				break;			
			case '2':
				printf(" Press '2' key for open Cash Drawer 2\n");
				CDBoxCMD(CDBoxCtlCMDOpen1);
				break;
			case '3':
				printf( "Press '3' key for open both of Cash Drawer\n");
				CDBoxCMD(CDBoxCtlCMDOpen1 | CDBoxCtlCMDOpen2);
				break;
			case '0':
				printf("\nExit now!!\n");
				return 0;
				break;
			
			default:
				printf("\nExit now!!\n");
				return 0;
				break;
		}
	}
}


//gotoxy
int gotoxy(int x, int y)
{
	char essq[100];
	char xstr[100];
	char ystr[100];
	/*
	** Convert the screen coordinates to strings
	*/
	sprintf(xstr,"%d",x);
	sprintf(ystr,"%d",y);
	/*
	** Build the escape sequence(vertical move)
	*/
	essq[0] ='\0';
	strcat(essq,"\033[");
	strcat(essq, ystr);

	strcat(essq,"d");
	strcat(essq,"\033[");
	strcat(essq, xstr);
	strcat(essq,"g");	
	printf("%s",essq);
	
	return 0;
}	

